CREATE TABLE JCR_SITEM(
	ID VARCHAR(255) NOT NULL PRIMARY KEY,
	VERSION INTEGER NOT NULL,
	CONTAINER_NAME VARCHAR(255) NOT NULL,
	PATH VARCHAR(255) NOT NULL
	);
CREATE INDEX JCR_IDX_ITEM_PATH ON JCR_SITEM(PATH);
CREATE TABLE JCR_SNODE(
	ID VARCHAR(255) NOT NULL PRIMARY KEY,
	ORDER_NUM INTEGER,
	PARENT_ID VARCHAR(255),
	CONSTRAINT JCR_FK_NODEPARENT FOREIGN KEY(PARENT_ID) REFERENCES JCR_SNODE(ID), 
	CONSTRAINT JCR_FK_NODE_ITEM FOREIGN KEY(ID) REFERENCES JCR_SITEM(ID)
	);
CREATE TABLE JCR_SPROPERTY(
	ID VARCHAR(255) NOT NULL PRIMARY KEY,
	TYPE INTEGER NOT NULL,
	PARENT_ID VARCHAR(255) NOT NULL,
	MULTIVALUED BOOLEAN NOT NULL,
	CONSTRAINT JCR_FK_PROPERTY_NODE FOREIGN KEY(PARENT_ID) REFERENCES JCR_SNODE(ID), 
	CONSTRAINT JCR_FK_PROPERTY_ITEM FOREIGN KEY(ID) REFERENCES JCR_SITEM(ID) 
	);
CREATE TABLE JCR_SVALUE(
	ID BIGINT generated by default as identity (START WITH 2, INCREMENT BY 1) NOT NULL PRIMARY KEY, 
	DATA VARBINARY(65535) NOT NULL,
	ORDER_NUM INTEGER,
	PROPERTY_ID VARCHAR(255) NOT NULL,
	CONSTRAINT JCR_FK_VALUE_PROPERTY FOREIGN KEY(PROPERTY_ID) REFERENCES JCR_SPROPERTY(ID)
	);