/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.services.jcr.core;

import javax.jcr.NamespaceRegistry;
import javax.jcr.Repository;
import javax.jcr.RepositoryException;
import javax.jcr.Session;

import org.exoplatform.services.jcr.core.nodetype.ExtendedNodeTypeManager;
import org.exoplatform.services.jcr.config.RepositoryEntry;

/**
 * Created by The eXo Platform SARL        .
 *
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov</a>
 * @version $Id: ManageableRepository.java 5150 2006-04-17 06:44:21Z geaz $
 */

public interface ManageableRepository extends Repository {

    void initWorkspace(String workspaceName, String rootNodeType) throws RepositoryException;

    boolean isWorkspaceInitialized(String workspaceName) throws RepositoryException;

    Session getSystemSession(String workspaceName) throws RepositoryException;
    
    String[] getWorkspaceNames();
    
    ExtendedNodeTypeManager getNodeTypeManager();
    
    NamespaceRegistry getNamespaceRegistry();

    RepositoryEntry getConfiguration();  
}
