/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.jcr.impl.core.lock;

import javax.jcr.RepositoryException;
import javax.jcr.lock.Lock;
import javax.jcr.lock.LockException;

import org.exoplatform.services.jcr.impl.core.NodeImpl;
import org.exoplatform.services.jcr.impl.core.SessionImpl;

/**
 * Created by The eXo Platform SARL        .
 * @author <a href="mailto:gennady.azarenkov@exoplatform.com">Gennady Azarenkov</a>
 * @version $Id: LockImpl.java 5150 2006-04-17 06:44:21Z geaz $
 */

public class LockImpl extends LockData implements Lock {
  
  private boolean live;
  private NodeImpl node;
  private LockManager manager;

  LockImpl(LockManager manager, LockData data, boolean live, NodeImpl node) {
    super((NodeImpl)data.getNode(), data.isDeep(), data.isSessionScoped());
    this.live = live;
    this.node = node; 
    this.manager = manager;
  }
  
  public String getLockOwner() {
    return lockHolder.getSession().getUserID();
  }


  public String getLockToken() {
    return ((SessionImpl)node.getSession()).getLockToken(lockHolder.getInternalUUID());
  }

  public boolean isLive() throws RepositoryException {
    return manager.getLock(node, false) != null;
  }


  public void refresh() throws LockException, RepositoryException {
    if(isLive())
      // we do not support timering yet
      return;
    else
      throw new LockException("Lock is not live");
      //manager.addLock(lockHolder, deep, sessionScoped);
  }

  // ---------------- impl --------------
  
  void setLive(boolean live) {
    this.live = live;
  }


}
