CREATE TABLE JCR_SITEM(
	ID VARCHAR(255) NOT NULL PRIMARY KEY,
	VERSION INTEGER NOT NULL,
	CONTAINER_NAME VARCHAR(255) NOT NULL,
	PATH VARCHAR(1024) NOT NULL
	);
CREATE INDEX JCR_IDX_SITEM_PATH ON JCR_SITEM(PATH(767));
CREATE INDEX JCR_IDX_SITEM_CONTAINER_NAME ON JCR_SITEM(CONTAINER_NAME(255));
CREATE INDEX JCR_IDX_SITEM_VERSION ON JCR_SITEM(VERSION);
CREATE TABLE JCR_SNODE(
	ID VARCHAR(255) NOT NULL PRIMARY KEY,
	ORDER_NUM INTEGER,
	PARENT_ID VARCHAR(255),
	CONSTRAINT JCR_FK_SNODE_PARENT FOREIGN KEY(PARENT_ID) REFERENCES JCR_SNODE(ID), 
	CONSTRAINT JCR_FK_SNODE_ITEM FOREIGN KEY(ID) REFERENCES JCR_SITEM(ID)
	);
CREATE INDEX JCR_IDX_SNODE_PARENT ON JCR_SNODE(ID, PARENT_ID);		
CREATE TABLE JCR_SPROPERTY(
	ID VARCHAR(255) NOT NULL PRIMARY KEY,
	TYPE INTEGER NOT NULL,
	PARENT_ID VARCHAR(255) NOT NULL,
	MULTIVALUED BOOLEAN NOT NULL,
	CONSTRAINT JCR_FK_SPROPERTY_NODE FOREIGN KEY(PARENT_ID) REFERENCES JCR_SNODE(ID), 
	CONSTRAINT JCR_FK_SPROPERTY_ITEM FOREIGN KEY(ID) REFERENCES JCR_SITEM(ID) 
	);
CREATE INDEX JCR_IDX_SPROPERTY_PARENT ON JCR_SPROPERTY(ID, PARENT_ID);	
CREATE TABLE JCR_SVALUE(
	ID SERIAL PRIMARY KEY, 
	DATA VARBINARY(65260) NOT NULL, 
	ORDER_NUM INTEGER,
	PROPERTY_ID VARCHAR(255) NOT NULL,
	CONSTRAINT JCR_FK_SVALUE_PROPERTY FOREIGN KEY(PROPERTY_ID) REFERENCES JCR_SPROPERTY(ID)
	);
CREATE INDEX JCR_IDX_SVALUE_PROPERTY ON JCR_SVALUE(ID, PROPERTY_ID);
CREATE INDEX JCR_IDX_SVALUE_DATA ON JCR_SVALUE(DATA(767));